Description

=begin

This makes the * operator operate more similarly to the + and - operators. The binary versions of + and - call methods named + and
-, while the unary versions call methods named +@ and -@. The binary * operator calls the method named *, but the unary *
operator calls the method to_a currently, and used to call to_ary in 1.8.6 (and at some point may have called to_splat).

| think this makes for more consistent behavior, and hopefully it isn't just a foolish consistency. | brought up this idea as a question in
Shugo Maeda's presentation at RubyKaigi 2009, and discussed it with Matz at Lone Star Ruby Conf 2009, and he thought the idea
had merit.

Here's a basic example how this would look:

class MultiplePersonality
def *@

[self, [self, self]]

end

end

mp = MultiplePersonality.new
p1, mp2 =*mp

This comes with a patch that appears to work from my simple testing, but this is my first time working with the internal ruby code, so |
apologize in advance if it doesn't do things correctly.

The patch modifies parse.y so the above is no longer a syntax error. It adds a USTAR token to the parser to represent that *@
token. It modifies the splatting to call *@ instead of to_a. Also, for backwards compatibility, it adds *@ to BasicObject, and has it call
to_aif it responds to to_a. This allows code that defines to_a and expects that the unary * operator will call to_a to still work.

This patch is mostly for consistency, but it also allows the programmer to make to_a return one thing, and the unary * operator return
something else. | can think of the following use case:

Represents an abstract set of rows in the database

class Dataset

defto_a
retrieve_database_rows
end

def *@

[self]

end

end

dataset = Dataset.new

Explicitly asking for an array means | want
an array of database rows represented by the

dataset.

rows = dataset.to_a

06/12/2025 1/3




If the dataset had any rows, | want to debug print
each row separately. However, if it did not have

any rows, | want to debug print the dataset itself.

p(*(rows.empty? ? dataset : rows))

I'd like to thank Eleanor McHugh for helping me find the key part of ruby that needed to be modified to support this (in
vm_insnhelper.c).
=end

History

#1 - 09/19/2009 06:08 AM - marcandre (Marc-Andre Lafortune)
- Category set to core

- Assignee set to matz (Yukihiro Matsumoto)
=begin
=end

#2 - 03/22/2010 11:00 AM - mame (Yusuke Endoh)

- Target version set to 3.0
=begin
Hi,
This makes the * operator operate more similarly to the + and - operators.
Interesting. It may be useful to simplify the semantics of multiple
assignment which is considered as one of most complex part of Ruby.

But it is very primitive part of Ruby semantics.
I think that such a spec change must not be included in 1.9.x.

So | set the target of this ticket to 2.0.

Yusuke Endoh mame@tsg.ne.jp

=end

#3 - 03/24/2010 10:16 PM - yugui (Yuki Sonoda)

=begin
On Sun, Aug 30, 2009 at 2:53 PM, Jeremy Evans redmine@ruby-lang.org wrote:

| think this makes for more consistent behavior, and hopefully it isn't just a foolish consistency. | brought up this idea as a question in Shugo
Maeda's presentation at RubyKaigi 2009, and discussed it with Matz at Lone Star Ruby Conf 2009, and he thought the idea had merit.

+1

Interesting. But it is so large change for the language feature to add
to 1.9.2. I do not include this feature in 1.9.2.

But | also think it can be added to 1.9.x. What do you think, matz?
Do you want add it to ruby 1.9.x?

-- Yuki Sonoda (Yugui)

=end

#4 - 09/14/2010 04:19 PM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Assigned

=begin
=end

#5 - 10/18/2011 09:16 AM - naruse (Yui NARUSE)
- Project changed from Ruby to 14

- Category deleted (core)

- Target version deleted (3.0)

#6 - 10/23/2011 05:21 PM - naruse (Yui NARUSE)
- Project changed from 14 to Ruby

#7 - 11/20/2012 08:51 PM - mame (Yusuke Endoh)
- Description updated

- Target version set to 3.0

#8 - 10/22/2017 12:29 AM - mame (Yusuke Endoh)

- Status changed from Assigned to Rejected

I'm closing this ticket since the discussion has been stalled completely.

| still think this is an interesting proposal. If you (or anyone else) are interested in this feature, please create a new ticket. It would be good to
reimplement it for trunk, and to investigate its merit on real-world applications and the compatibility problem.

Files

unary_star_op_svn.diff 3.99 KB 08/30/2009 jeremye (Jeremy Evans)
